#AUTOGENERATED! DO NOT EDIT! File to edit: dev/01_pipeline.ipynb (unless otherwise specified).

__all__ = ['Pipeline']

#Cell
from typing import List, Dict
from .core import *


class Pipeline:
    def __init__(self, train: List[Dict[str, object]], dev: List[Dict[str, object]], test: List[Dict[str, object]] = None):
        self.datasets = {
            'train': train,
            'dev': dev,
            'all': train + dev
        }
        if test:
            self.datasets.update({
                'test': test,
                'all': train + dev + test
            })

    def apply(self, func, *args, **kwargs):
        """Apply an existing function to all datasets"""
        res = {}
        for k, dataset in self.datasets.items():
            res[k] = func(dataset, *args, **kwargs)
        return res
